#include <stdio.h>
#include "interface.h"
//#include "c:\robot interface\include\mazegraphics.h"

/* SCOUT compatible! */

extern SensorType Sensors;
extern HANDLE hCom1;

// find the simplified delta-angle from one heading to another.
int DiffAng(int dest, int src)
{
	// Note that INTABS is a macro defined in useful.h that finds the
	// absolute value of an integer.  There are a few other macros there
	// that you may find useful.  
	if (INTABS(dest-src) <= 1800)
		return dest-src;
	dest = (dest + 1800) % 3600;
	src = (src + 1800) % 3600;
	return dest-src;
}

// turn turnang tenths of a degree from the current heading.
void Turn(int turnang)
{
	int deltaang, intang, ang, goalang, done, rv;

	intang = ang = Sensors.angle;
	goalang = (ang + turnang) % 3600;
	deltaang = 0;

	done = 0;
	while (!done) {
		Sleep(100);
		rv = DiffAng(goalang, ang) / 8;
		RMove(rv, (-rv));
		ang = Sensors.angle;
		done = (INTABS(goalang - ang) < 15) && (INTABS(Sensors.rVel) < 60);
	}
	RMove(0,0);
}

void main()
{
	char buf[256];
	char mytxt[256];
	int lv, rv;
	
	printf("Entering program. hit enter.\n");
	getchar();

	if (OpenSerial()) {
		printf("There's been a serial error!\n");
		getchar();


	}
	GS(); // make sure that Sensors is up-to-date.
	Sleep(100);
	SonarsOn();
	Sleep(1000);
	GS();
	//RMove(-20,-20);
	//Turn(900);
	printf("Please hit enter and hold a bumper in\n");

	getchar();
	//while (1) {
	GS();


	//	RMove(0,0);
	//	Sleep(500);
    printf("bumper: %f\n", 
		(double)Sensors.bumper);
	Sleep(500);
	//	sprintf(mytxt, "rvelocity %d lvelocity %d\n",
	//		Sensors.rVel, Sensors.lVel);
	printf("Enter right wheel velocity and left wheel velocity>> \n");
	scanf("%d %d", &rv, &lv);
	RMove(rv,lv);
	Sleep(2000);
	RMove(0,0);

	SonarsOff();
	Sleep(100);
	SonarsOff();
		
	//OutputText("\nThat\'s all, folks!\n");
	Sleep(500);

	// remember to close the Serial port!!! //
	CloseSerial();
	
}

